{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     TQRLabel    
        .

              , , 2002.
                     menshov_s@mail.ru
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

unit QRMyLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRpt, Qrctrls;

type
  TQRMyLabel = class(TQRLabel)
  private
    FAngle:word;    //    
    procedure SetAngle(Value:word);
    procedure PaintText(OfsX,OfsY:Integer;C:TCanvas);
  protected
    procedure Paint; override;
    procedure Print(OfsX:Integer;OfsY:Integer); override;
  public
    constructor Create(AOwner:TComponent);override;
  published
    property Angle:word read FAngle write SetAngle default 0;
  end;

procedure Register;

implementation

{$R QRMyLabel.res}

procedure Register;
begin
  RegisterComponents('QReport', [TQRMyLabel]);
end;

{ TQRMyLabel }

constructor TQRMyLabel.Create(AOwner: TComponent);
begin
  inherited;
  AutoSize:=false;
  FAngle:=0;
end;

procedure TQRMyLabel.Paint;
begin
  PaintText(0,0,Canvas);
end;

procedure TextOutAngle(C:TCanvas;x,y:Integer;A:Word;S:string);
var
  LF:TLogFont;
  NewFontHandle,OldFontHandle: HFONT;
begin
  GetObject(C.Font.Handle,SizeOf(LF),Addr(LF));
  LF.lfEscapement:=A*10;
  LF.lfQuality:=DEFAULT_QUALITY;
  NewFontHandle:=CreateFontIndirect(LF);
  OldFontHandle:=SelectObject(C.Handle,NewFontHandle);
  C.TextOut(x,y,S);
  NewFontHandle:=SelectObject(C.Handle,OldFontHandle);
  DeleteObject(NewFontHandle);
end;

procedure TQRMyLabel.PaintText(OfsX,OfsY:Integer;C: TCanvas);
var
  x,y,NewX,NewY:integer;
  RAngle:real;
  R:TRect;
begin
  R:=Rect(OfsX,OfsY,OfsX+Width,OfsY+Height);

  C.Brush.Color:=Color;

  if Transparent then C.Brush.Style:=bsClear;

  C.FillRect(R);
  C.Font.Assign(Font);
  
  x:=-C.TextWidth(Caption)div 2;
  y:=-C.TextHeight(Caption)div 2;
  RAngle:=FAngle/180*Pi;
  NewX:=OfsX+Width div 2+Round(x*Cos(RAngle)+y*Sin(RAngle));
  NewY:=OfsY+Height div 2-Round(x*Sin(RAngle)-y*Cos(RAngle));

  TextOutAngle(C,NewX,NewY,FAngle,Caption);

  C.Brush.Style:=bsSolid;
  C.Brush.Color:=Frame.Color;

  if Frame.DrawLeft then
    C.FillRect(Rect(R.Left,R.Top,R.Left+Frame.Width,R.Bottom));

  if Frame.DrawBottom then
    C.FillRect(Rect(R.Left,R.Bottom-Frame.Width,R.Right,R.Bottom));

  if Frame.DrawRight then
    C.FillRect(Rect(R.Right-Frame.Width,R.Top,R.Right,R.Bottom));

  if Frame.DrawTop then
    C.FillRect(Rect(R.Left,R.Top,R.Right,R.Top+Frame.Width));
end;

procedure TQRMyLabel.Print(OfsX: Integer; OfsY: Integer);
begin
  PaintText(Left+QRPrinter.XPos(OfsX),
            Top+QRPrinter.YPos(OfsY),
            QRPrinter.Canvas);
end;

procedure TQRMyLabel.SetAngle(Value: word);
begin
  if FAngle<>Value then
  begin
    FAngle:=Value;
    Invalidate;
  end;
end;

end.
